<template>
  <el-row class="user h-100p">
    <el-col :span="5" class="h-100p">
      <div class="h-100p">
        <el-scrollbar>
          <basic-container class="my-basic-con">
            <avue-tree :option="treeOption" :data="treeData" @node-click="nodeClick" />
          </basic-container>
        </el-scrollbar>
      </div>
    </el-col>
    <el-col :span="19">
      <basic-container>
        <avue-crud :option="option" :search.sync="search" :table-loading="loading" :data="data" ref="crud"
          :before-close="beforeClose" v-model="form" :permission="permissionList" @row-del="rowDel"
          @row-update="rowUpdate" @row-save="rowSave" :before-open="beforeOpen" :page.sync="page"
          @search-change="searchChange" @search-reset="searchReset" @selection-change="selectionChange"
          @current-change="currentChange" @size-change="sizeChange" @refresh-change="refreshChange" @on-load="onLoad">
          <!-- 自 定义按钮 -->
          <template slot-scope="{ row, index }" slot="menu">
            <el-link class="marleft10" :underline="false" type="primary" icon="el-icon-edit" size="small"
              @click="editKJ(row, index)">编辑
            </el-link>
            <el-link class="marleft10" :underline="false" type="primary" icon="el-icon-delete" size="small"
              @click="$refs.crud.rowDel(row, index)">删除
            </el-link>
          </template>

          <!-- 参建项目 -->
          <template slot-scope="{ type }" slot="projectAndUserListForm">
            <div class="flexStar marbottom10" v-for="(el, key) in fromss.projectAndUserList" :key="key">
              <el-input v-model="el.projectName" :disabled="true"></el-input>
              <el-select class="marleft10" v-model="el.contractName" placeholder="请选择" @change="contractChange(key)">
                <el-option v-for="(item, index) in fromss.projectAndUserList[key]
                  .dataInfo" :key="item.id" :label="item.contractName" :value="item.id">
                  <span style="float: left">{{ item.contractName }}</span>
                  <el-button @click.stop="deleteProject(key, type, index)"
                    style="float: right; margin-right: 5px; margin-top: 3px" type="danger" size="mini"
                    icon="el-icon-delete" circle></el-button>
                </el-option>
              </el-select>
              <!-- 是否可以编辑合同段角色 -->
              <template v-if="!el.isCanEditProjectRole">
                <el-input class="marleft10" v-model="el.roleName" :disabled="true"></el-input>

                <el-button @click="el.isCanEditProjectRole = true" class="marleft10" type="warning" icon="el-icon-edit"
                  :disabled="deletexiangmu" circle></el-button>
              </template>
              <template v-else>
                <el-select :disabled="type == 'view'" class="marleft10" v-model="el.roleId" filterable placeholder="请选择"
                  @change="(e) => contractRoleChange(key, el.contractId, e)">
                  <el-option v-for="item in roleIdsData" :key="item.roleId" :label="item.roleName" :value="item.roleId">
                  </el-option>
                </el-select>

                <el-button @click="updateContractRole(key)" class="marleft10" type="primary"
                  icon="el-icon-document-checked" :disabled="deletexiangmu" circle></el-button>
              </template>

              <el-button @click="deleteProject2(key, type)" class="marleft10" type="danger" icon="el-icon-delete"
                :disabled="deletexiangmu" circle></el-button>
            </div>
          </template>

          <!-- 参与项目自定义表单 -->
          <template slot="projectIdForm" slot-scope="{ type }">
            <el-select v-model="fromss.projectId" :disabled="type == 'view'" placeholder="请选择">
              <el-option v-for="item in projectData" :key="item.id" :label="item.projectName" :value="item.id">
              </el-option>
            </el-select>
          </template>

          <!-- 合同段自定义表单 -->
          <template slot="contractIdForm" slot-scope="{ type }">
            <el-select :disabled="type == 'view'" v-model="fromss.contractId" placeholder="请选择">
              <el-option v-for="item in contractData" :key="item.id" :label="item.contractName" :value="item.id">
              </el-option>
            </el-select>
          </template>

          <!-- 用户类型自定义表单 -->
          <template slot-scope="{ type }" slot="roleIdsForm">
            <div class="flexStar">
              <el-select :disabled="type == 'view'" v-model="fromss.roleIds" filterable placeholder="请选择">
                <el-option v-for="item in roleIdsData" :key="item.roleId" :label="item.roleName" :value="item.roleId">
                </el-option>
              </el-select>
              <el-button v-show="type !== 'view'" class="marleft10" type="warning" size="mini"
                @click="addProject(type)">确认添加
              </el-button>
            </div>
          </template>

          <template slot="menuLeft">
            <el-button type="primary" size="small" icon="el-icon-plus" @click="addKJ()">新 增
            </el-button>
            <el-button type="danger" size="small" plain icon="el-icon-delete" v-if="permission.user_delete"
              @click="handleDelete">删 除
            </el-button>
            <el-button type="info" size="small" plain v-if="permission.user_role" icon="el-icon-user"
              @click="handleGrant">角色配置
            </el-button>
            <el-button type="info" size="small" plain v-if="permission.user_reset" icon="el-icon-refresh"
              @click="handleReset">密码重置
            </el-button>
            <el-button type="info" size="small" plain v-if="userInfo.role_name.includes('admin')" icon="el-icon-setting"
              @click="handlePlatform">平台配置
            </el-button>
            <el-button type="info" size="small" plain v-if="userInfo.role_name.includes('admin')"
              icon="el-icon-coordinate" @click="handLock">账号封禁
            </el-button>
            <el-button type="info" size="small" plain v-if="userInfo.role_name.includes('admin')"
              icon="el-icon-coordinate" @click="handleLock">账号解封
            </el-button>
            <el-button type="success" size="small" plain v-if="userInfo.role_name.includes('admin')"
              icon="el-icon-upload2" @click="handleImport">导入
            </el-button>
            <el-button type="warning" size="small" plain v-if="userInfo.role_name.includes('admin')"
              icon="el-icon-download" @click="handleExport">导出
            </el-button>
          </template>
          <template slot-scope="{ row }" slot="tenantName">
            <el-tag>{{ row.tenantName }}</el-tag>
          </template>
          <template slot-scope="{ row }" slot="roleName">
            <el-tag>{{ row.roleName }}</el-tag>
          </template>
          <template slot-scope="{ row }" slot="deptName">
            <el-tag>{{ row.deptName }}</el-tag>
          </template>
          <template slot-scope="{ row }" slot="userTypeName">
            <el-tag>{{ row.userTypeName }}</el-tag>
          </template>
        </avue-crud>
        <el-dialog title="用户角色配置" append-to-body :visible.sync="roleBox" width="345px">
          <el-tree :data="roleGrantList" show-checkbox check-strictly default-expand-all node-key="id" ref="treeRole"
            :default-checked-keys="roleTreeObj" :props="props" style="max-height: 400px; overflow-y: auto">
          </el-tree>

          <span slot="footer" class="dialog-footer">
            <el-button @click="roleBox = false">取 消</el-button>
            <el-button type="primary" @click="submitRole">确 定</el-button>
          </span>
        </el-dialog>
        <el-dialog title="用户数据导入" append-to-body :visible.sync="excelBox" width="555px">
          <avue-form :option="excelOption" v-model="excelForm" ref="excelForm">
            <template slot="excelTemplate">
              <el-button type="primary" @click="handleTemplate">
                点击下载<i class="el-icon-download el-icon--right"></i>
              </el-button>
            </template>
          </avue-form>
        </el-dialog>
        <el-dialog title="用户平台配置" append-to-body :visible.sync="platformBox">
          <avue-crud :option="platformOption" :table-loading="platformLoading" :data="platformData" ref="platformCrud"
            v-model="platformForm" :before-open="platformBeforeOpen" :page.sync="platformPage"
            :permission="platformPermissionList" @row-update="platformRowUpdate" @search-change="platformSearchChange"
            @search-reset="platformSearchReset" @selection-change="platformSelectionChange"
            @current-change="platformCurrentChange" @size-change="platformSizeChange"
            @refresh-change="platformRefreshChange" @on-load="platformOnLoad">
            <template slot-scope="{ row }" slot="tenantName">
              <el-tag>{{ row.tenantName }}</el-tag>
            </template>
            <template slot-scope="{ row }" slot="userTypeName">
              <el-tag>{{ row.userTypeName }}</el-tag>
            </template>
          </avue-crud>
        </el-dialog>
      </basic-container>
    </el-col>
  </el-row>
</template>

<script>
import {
  getList,
  getUser,
  getUserPlatform,
  remove,
  update,
  updatePlatform,
  add,
  grant,
  resetPassword,
  lock,
  unlock,
  removeUserProjectInfoAndRoleById,
  importUserExcel
} from "@/api/system/user";
import { getProjectListPage } from "@/api/manager/projectinfo";

import {
  findContractByProjectId,
  removeUsersByIds,
  updateBatchUserRole,
} from "@/api/manager/contractinfo";
import { exportBlob } from "@/api/common";
import { getDeptTree, getDeptLazyTree } from "@/api/system/dept";
import {
  roletree,
  treeUser,
  findProjectAndContractList,
  saveUserInfoByProjectTow,
} from "@/api/system/role";
// import { getPostList } from "@/api/system/post";
import { mapGetters } from "vuex";
import website from "@/config/website";
import { getToken } from "@/util/auth";
import { downloadXls } from "@/util/util";
import { dateNow } from "@/util/date";
import NProgress from "nprogress";
import "nprogress/nprogress.css";

export default {
  data() {
    const validatePass = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("请输入密码"));
      } else {
        callback();
      }
    };
    const validatePass2 = (rule, value, callback) => {
      if (value === "") {
        callback(new Error("请再次输入密码"));
      } else if (value !== this.form.password) {
        callback(new Error("两次输入密码不一致!"));
      } else {
        callback();
      }
    };
    const phoneRules = (rule, value, callback) => {
      // if (!/^1[345789]\d{9}$/.test(value)) {
      //  if (!/^(13[0-9]|14[579]|15[0-3,5-9]|16[6]|17[0135678]|18[0-9]|19[89])\d{8}$/.test(value)) {
      if (!/^1[3-9]\d{9}$/.test(value)) {
        callback(new Error("请输入正确的手机号"));
      } else {
        callback();
      }
    };
    const idNumberRules = (rule, value, callback) => {
      if (!value) {
        callback();
      } else {
        // if (!/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[12])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(value)) {
        //  /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)
        if (!/(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/.test(value)) {
          callback(new Error("请输入正确的身份证号"));
        } else {
          callback();
        }
      }
    };
    const projectAndUserListRules = (rule, value, callback) => {
      if (this.fromss.projectAndUserList.length > 0) {
        callback();
      } else {
        callback(new Error("请设置参建项目"));
      }
    };
    return {
      deletexiangmu: false,
      addData: {
        tenantId: "",
        deptId: "",
      },
      form: {},
      search: {},
      roleBox: false,
      excelBox: false,
      platformBox: false,
      initFlag: true,
      selectionList: [],
      query: {},
      loading: true,
      platformLoading: false,
      page: {
        pageSize: 20,
        currentPage: 1,
        total: 0,
      },
      platformPage: {
        pageSize: 10,
        currentPage: 1,
        total: 0,
      },
      init: {
        roleTree: [],
        deptTree: [],
      },
      props: {
        label: "title",
        value: "key",
      },
      roleGrantList: [],
      roleTreeObj: [],
      treeDeptId: "",
      treeData: [],
      treeOption: {
        nodeKey: "id",
        lazy: true,
        treeLoad: function (node, resolve) {
          const parentId = node.level === 0 ? 0 : node.data.id;
          getDeptLazyTree(parentId).then((res) => {
            resolve(
              res.data.data.map((item) => {
                return {
                  ...item,
                  leaf: !item.hasChildren,
                };
              })
            );
          });
        },
        addBtn: false,
        menu: false,
        size: "small",
        props: {
          labelText: "标题",
          label: "title",
          value: "value",
          children: "children",
        },
      },
      fromss: {
        userId: "", //
        projectAndUserList: [],
        projectId: "", //参与项项目
        contractId: "", //合同段
        roleIds: "", //用户类型
      },
      projectData: [], //参与项项目
      contractData: [], //合同段
      roleIdsData: [], //用户类型
      option: {
        height: "auto",
        calcHeight: 80,
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        selection: true,
        addBtn: false,
        // viewBtn: true,
        editBtn: false,
        delBtn: false,
        dialogType: "drawer",
        dialogClickModal: false,
        column: [
          {
            label: "登录账号",
            prop: "account",
            search: true,
            display: false,
          },
          {
            label: "所属租户",
            prop: "tenantName",
            slot: true,
            display: false,
          },
          {
            label: "用户姓名",
            prop: "realName",
            search: true,
            display: false,
          },
          {
            label: "所属角色",
            prop: "roleName",
            slot: true,
            display: false,
          },
          {
            label: "所属部门",
            prop: "deptName",
            slot: true,
            display: false,
            value: "",
          },
          {
            label: "用户平台",
            prop: "userTypeName",
            slot: true,
            display: false,
          },
          {
            label: "密码",
            prop: "plaintextPassword",
            slot: true,
            display: false,
          },
          {
            label: "用户平台",
            type: "checkbox",
            dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
            props: {
              label: "dictValue",
              value: "dictKey",
            },
            dataType: "number",
            search: true,
            hide: true,
            display: false,
            prop: "userType",
            rules: [
              {
                required: true,
                message: "请选择用户平台",
                trigger: "blur",
              },
            ],
          },
        ],
        group: [
          {
            label: "基础信息",
            prop: "baseInfo",
            icon: "el-icon-user-solid",
            column: [
              {
                label: "所属租户",
                prop: "tenantId",
                type: "tree",
                dicUrl: "/api/blade-system/tenant/select",
                props: {
                  label: "tenantName",
                  value: "tenantId",
                },
                hide: !website.tenantMode,
                addDisplay: website.tenantMode,
                editDisplay: website.tenantMode,
                viewDisplay: website.tenantMode,
                rules: [
                  {
                    required: true,
                    message: "请输入所属租户",
                    trigger: "change",
                  },
                ],
                span: 24,
              },
              {
                label: "登录账号",
                prop: "account",
                rules: [
                  {
                    // 动态校验：若手机号为空则账号必填，否则可选（后续会自动用手机号填充）
                    validator: (rule, value, callback) => {
                      if (!value && !this.form.phone) {
                        callback(new Error("请输入登录账号")); // 账号和手机号都为空时提示
                      } else {
                        callback(); // 有一个不为空则通过
                      }
                    },
                    trigger: "blur",
                  },
                ],
              },
              {
                label: "密码",
                prop: "password",
                hide: true,
                editDisplay: false,
                viewDisplay: false,
                rules: [
                  { required: true, validator: validatePass, trigger: "blur" },
                ],
              },
              {
                label: "确认密码",
                prop: "password2",
                hide: true,
                editDisplay: false,
                viewDisplay: false,
                rules: [
                  { required: true, validator: validatePass2, trigger: "blur" },
                ],
              },
              {
                label: "用户平台",
                type: "checkbox",
                dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
                props: {
                  label: "dictValue",
                  value: "dictKey",
                },
                dataType: "number",
                hide: false,
                prop: "userType",
                rules: [
                  {
                    required: true,
                    message: "请选择用户平台",
                    trigger: "blur",
                  },
                ],
              },
            ],
          },
          {
            label: "详细信息",
            prop: "detailInfo",
            icon: "el-icon-s-order",
            column: [
              {
                label: "用户姓名",
                prop: "realName",
                rules: [
                  {
                    required: true,
                    message: "请输入用户姓名",
                    trigger: "blur",
                  },
                  {
                    min: 2,
                    max: 20,
                    message: "姓名长度在2到5个字符",
                  },
                ],
              },
              {
                label: "手机号码",
                prop: "phone",
                rules: [
                  {
                    required: true,
                    validator: phoneRules,
                    trigger: "blur",
                  },
                ],
              },
              {
                label: "身份证号",
                prop: "idNumber",
                rules: [
                  {
                    required: false,
                    validator: idNumberRules,
                    trigger: "blur",
                  },
                ],
              },

              {
                label: "所属部门",
                prop: "deptId",
                type: "tree",
                // multiple: true,
                dicData: [],
                value: "",
                typeslot: true,
                props: {
                  label: "title",
                  value: "value",
                },
                checkStrictly: false,
                // slot: true,
                rules: [
                  {
                    required: true,
                    message: "请选择所属部门",
                    trigger: "change",
                  },
                ],
              },
              {
                label: "证书编号",
                prop: "accCode",
                placeholder: "仅用于第三方便签",
                rules: [
                  {
                    required: false,
                    message: "仅用于第三方便签",
                    trigger: "blur",
                  },
                ],
              },
            ],
          },
          {
            label: "职能描述",
            prop: "dutyInfo",
            icon: "el-icon-s-custom",
            column: [
              {
                label: "参建项目",
                prop: "projectAndUserList",
                span: 24,
                addDisplay: true, // 新增时不显示
                rules: [
                  {
                    required: true,
                    validator: projectAndUserListRules,
                    trigger: "change",
                  },
                ],
              },
              {
                label: "参与项目",
                prop: "projectId",
                span: 16,
                addDisplay: true, // 新增时不显示
              },
              {
                label: "合同段",
                prop: "contractId",
                span: 16,
                addDisplay: true, // 新增时不显示
              },
              {
                label: "用户类型",
                prop: "roleIds",
                span: 16,
                addDisplay: true, // 新增时不显示
              },
              {
                label: "单位名称",
                prop: "companyName",
                span: 16,
                addDisplay: true, // 新增时不显示
              },
              {
                label: "职位",
                prop: "position",
                span: 16,
                addDisplay: true, // 新增时不显示
              },
              {
                label: "允许登录",
                type: "select",
                span: 16,
                prop: "status",
                dicData: [
                  { value: 1, label: "是" },
                  { value: 0, label: "否" },
                ],
                rules: [
                  {
                    required: true,
                    message: "请选择是否允许登录",
                    trigger: "change",
                  },
                ],
              },
            ],
          },
        ],
      },
      data: [],
      platformQuery: {},
      platformSelectionList: [],
      platformData: [],
      platformForm: {},
      platformOption: {
        tip: false,
        searchShow: true,
        searchMenuSpan: 6,
        border: true,
        index: true,
        selection: true,
        viewBtn: true,
        dialogClickModal: false,
        menuWidth: 120,
        editBtnText: "配置",
        column: [
          {
            label: "登录账号",
            prop: "account",
            search: true,
            display: false,
          },
          {
            label: "所属租户",
            prop: "tenantName",
            slot: true,
            display: false,
          },
          {
            label: "用户姓名",
            prop: "realName",
            search: true,
            display: false,
          },
          {
            label: "用户平台",
            prop: "userTypeName",
            slot: true,
            display: false,
          },
          {
            label: "用户平台",
            type: "checkbox",
            dicUrl: "/api/blade-system/dict/dictionary?code=user_type",
            props: {
              label: "dictValue",
              value: "dictKey",
            },
            dataType: "number",
            search: true,
            hide: true,
            display: false,
            prop: "userType",
            rules: [
              {
                required: true,
                message: "请选择用户平台",
                trigger: "blur",
              },
            ],
          },
          {
            label: "用户拓展",
            prop: "userExt",
            type: "textarea",
            minRows: 8,
            span: 24,
            overHidden: true,
            row: true,
            hide: true,
          },
        ],
      },
      excelForm: {},
      excelOption: {
        submitBtn: false,
        emptyBtn: false,
        column: [
          {
            label: "模板上传",
            prop: "excelFile",
            accept: ".xls,.xlsx",
            type: "upload",
            drag: true,
            loadText: "模板上传中，请稍等",
            span: 24,
            propsHttp: {
              res: "data",
            },
            tip: "请上传 .xls,.xlsx 标准格式文件",
            action: "#",
            httpRequest: async (file) => {
              const formData = new FormData();
              formData.append("file", file.file);

              const { data: res } = await importUserExcel(formData);
              if (res.code === 200) {
                this.excelBox = false;
                // 刷新数据列表
                this.refreshChange();
                if (res.error) {
                  this.$message.error(res.msg);
                } else {
                  this.$message.success(res.msg);
                }
              } else {
                this.$message.error(res.msg);
              }
            }
          },
          // {
          //   label: "数据覆盖",
          //   prop: "isCovered",
          //   type: "switch",
          //   align: "center",
          //   width: 80,
          //   dicData: [
          //     {
          //       label: "否",
          //       value: 0,
          //     },
          //     {
          //       label: "是",
          //       value: 1,
          //     },
          //   ],
          //   value: 0,
          //   slot: true,
          //   rules: [
          //     {
          //       required: true,
          //       message: "请选择是否覆盖",
          //       trigger: "blur",
          //     },
          //   ],
          // },
          {
            label: "模板下载",
            prop: "excelTemplate",
            formslot: true,
            span: 24,
          },
        ],
      },
    };
  },
  watch: {
    "form.tenantId"() {
      if (this.form.tenantId !== "" && this.initFlag) {
        this.initData(this.form.tenantId);
      }
    },
    // "excelForm.isCovered"() {
    //   if (this.excelForm.isCovered !== "") {
    //     const column = this.findObject(this.excelOption.column, "excelFile");
    //     column.action = `/api/blade-user/import-user?isCovered=${this.excelForm.isCovered}`;
    //   }
    // },
    "fromss.projectId": function () {
      this.fromss.contractId = "";
      if (this.fromss.projectId) {
        this.findContractByProjectId(this.fromss.projectId);
      } else {
        this.contractData = [];
      }
    },
  },
  computed: {
    ...mapGetters(["userInfo", "permission"]),
    permissionList() {
      return {
        addBtn: this.vaildData(this.permission.user_add, false),
        viewBtn: this.vaildData(this.permission.user_view, false),
        delBtn: this.vaildData(this.permission.user_delete, false),
        editBtn: this.vaildData(this.permission.user_edit, false),
      };
    },
    platformPermissionList() {
      return {
        addBtn: false,
        viewBtn: false,
        delBtn: false,
        editBtn: this.vaildData(this.permission.user_edit, false),
      };
    },
    ids() {
      let ids = [];
      this.selectionList.forEach((ele) => {
        ids.push(ele.id);
      });
      return ids.join(",");
    },
  },
  mounted() {
    // 非租户模式默认加载管理组数据
    if (!website.tenantMode) {
      this.initData(website.tenantId);
    }
    if (this.$route.query.tankai) {
      this.$refs.crud.rowAdd();
      this.getProjectList();

      this.initData(website.tenantId);
    }
  },
  methods: {
    //#region 弹框事件及方法
    addKJ() {
      this.getProjectList(); //项目类型
      this.treeUser(); //获取用户类型枚举
      this.fromss.projectAndUserList = [];
      this.fromss.projectId = "";
      this.fromss.userId = "";
      this.fromss.contractId = "";
      this.fromss.roleIds = ""; //合同段Id
      this.contractData = []; //合同段枚举
      this.form.deptName = this.addData.deptId;
      const column = this.findObject(this.option.group, "deptId");
      column.value = this.addData.deptId;

      this.$refs.crud.rowAdd();
    },
    addProject(type) {
      //确定添加参建项目
      if (type == "add") {
        this.addfangfa();
      } else {
        const tag = true;
        if (!this.fromss.projectId) {
          this.$message({
            type: "error",
            message: "请选择参与项目!",
          });
          return;
        }
        if (!this.fromss.contractId) {
          this.$message({
            type: "error",
            message: "请选择合同段!",
          });
          return;
        }
        if (!this.fromss.roleIds) {
          this.$message({
            type: "error",
            message: "请选择用户类型!",
          });
          return;
        }
        if (tag) {
          this.saveUserInfoByProjectTow([
            {
              projectId: this.fromss.projectId,
              contractId: this.fromss.contractId,
              roleId: this.fromss.roleIds,
              userId: this.fromss.userId,
            },
          ]);
        }
      }
    },
    addfangfa() {
      //添加时确定添加按钮方法处理
      if (!this.fromss.projectId) {
        this.$message({
          type: "error",
          message: "请选择参与项目!",
        });
        return;
      }
      if (!this.fromss.contractId) {
        this.$message({
          type: "error",
          message: "请选择合同段!",
        });
        return;
      }
      if (!this.fromss.roleIds) {
        this.$message({
          type: "error",
          message: "请选择用户类型!",
        });
        return;
      }
      let tag = true,
        index = "";

      if (this.fromss.projectAndUserList.length > 0) {
        this.fromss.projectAndUserList.forEach((val, k) => {
          if (val.projectId == this.fromss.projectId) {
            index = k;
            tag = false;
          }
        });
      }
      let das;
      if (tag) {
        das = {
          projectId: this.fromss.projectId,
          contractId: this.fromss.contractId,
          roleIds: this.fromss.roleIds,
          roleName: "",
          dataInfo: [
            {
              contractName: "",
              id: this.fromss.contractId,
              roleIds: this.fromss.roleIds,
              roleName: "",
              roleType: "",
            },
          ],
          contractName: this.fromss.contractId,
        };
        // 参与项目
        this.projectData.forEach((vas) => {
          if (vas.id == this.fromss.projectId) {
            das.projectName = vas.projectName;
          }
        });
        // 合同段
        this.contractData.forEach((vas) => {
          if (vas.id == this.fromss.contractId) {
            das.dataInfo[0].contractName = vas.contractName;
          }
        });
        // 用户类型
        this.roleIdsData.forEach((vas) => {
          if (vas.roleId == this.fromss.roleIds) {
            das.roleName = vas.roleName;
          }
        });
        //  添加进去
        this.fromss.projectAndUserList.push(das);
        this.$message({
          type: "success",
          message: "添加成功",
        });
      } else {
        let tags = true;
        this.fromss.projectAndUserList[index].dataInfo.forEach((val) => {
          if (val.id == this.fromss.contractId) {
            tags = false;
          }
        });
        if (tags) {
          das = {
            contractName: "",
            id: this.fromss.contractId,
            roleIds: this.fromss.roleIds,
            roleName: "",
            roleType: "",
          };
          // 参与项目
          this.projectData.forEach((vas) => {
            if (vas.id == this.fromss.projectId) {
              das.projectName = vas.projectName;
            }
          });
          // 合同段
          this.contractData.forEach((vas) => {
            if (vas.id == this.fromss.contractId) {
              das.contractName = vas.contractName;
            }
          });
          // 用户类型
          this.roleIdsData.forEach((vas) => {
            if (vas.roleId == this.fromss.roleIds) {
              das.roleName = vas.roleName;
            }
          });
          //  添加进去
          this.fromss.projectAndUserList[index].dataInfo.push(das);
          this.$message({
            type: "success",
            message: "添加成功",
          });
        } else {
          this.$message({
            type: "error",
            message: "当前合同段已添加,无法继续添加",
          });
        }
      }
    },
    contractChange(key) {
      //合同段changge事件
      this.fromss.projectAndUserList[key].dataInfo.forEach((val) => {
        if (this.fromss.projectAndUserList[key].contractName == val.id) {
          this.fromss.projectAndUserList[key].roleId = val.roleId;
          this.fromss.projectAndUserList[key].contractId = val.id;
          if (val.roleType) {
            this.fromss.projectAndUserList[key].roleName =
              val.roleType + " | " + val.roleName;
          } else {
            this.fromss.projectAndUserList[key].roleName = val.roleName;
          }
        }
      });
    },
    contractRoleChange(index, contractId, roleId) {
      //合同段用户类型change事件
      console.log(index, contractId, roleId);
      const subIndex = this.fromss.projectAndUserList[index].dataInfo.findIndex(
        (item) => item.id === contractId
      );
      const role = this.roleIdsData.find((item) => item.roleId === roleId);

      this.$set(this.fromss.projectAndUserList[index].dataInfo, subIndex, {
        ...this.fromss.projectAndUserList[index].dataInfo[subIndex],
        ...role,
      });
    },
    async editKJ(row, index) {
      //编辑用户
      console.log(row);
      this.fromss.userId = row.id; //用户ID
      this.fromss.contractId = ""; //合同段Id
      this.contractData = []; //合同段枚举
      this.getProjectList(); //项目类型
      this.treeUser(); //用户类型枚举
      this.findProjectAndContractList(row.id); //编辑获取参建项目
      this.$refs.crud.rowEdit(row, index);
    },
    deleteProject2(key, type) {
      //删除参建项目一条项目
      if (type == "add") {
        this.fromss.projectAndUserList.splice(
          this.fromss.projectAndUserList[key],
          1
        );
      } else {
        this.removeUserProjectInfoAndRoleById(
          this.fromss.projectAndUserList[key].dataInfo[0].id
        );
      }
    },
    deleteProject(key, type, index) {
      //删除参建项目按钮
      if (type == "add") {
        if (this.fromss.projectAndUserList[key].dataInfo.length == 1) {
          this.fromss.projectAndUserList.splice(
            this.fromss.projectAndUserList[key],
            1
          );
        } else {
          this.fromss.projectAndUserList[key].dataInfo.splice(
            this.fromss.projectAndUserList[key].dataInfo[index],
            1
          );
          this.fromss.projectAndUserList[key].roleName =
            this.fromss.projectAndUserList[key].dataInfo[0].roleName;
          this.fromss.projectAndUserList[key].contractName =
            this.fromss.projectAndUserList[key].dataInfo[0].id;
          this.fromss.projectAndUserList[key].contractId =
            this.fromss.projectAndUserList[key].dataInfo[0].id;
        }
      } else {
        this.removeUsersByIds(
          this.fromss.projectAndUserList[key].dataInfo[index].id
        );
      }
    },
    async removeUserProjectInfoAndRoleById(id) {
      //参建项目删除一条项目
      this.deletexiangmu = true;
      try {
        const { data: res } = await removeUserProjectInfoAndRoleById({ id });
        console.log(res);
        if (res.code == 200) {
          await this.findProjectAndContractList(this.fromss.userId);
        }
        this.deletexiangmu = false;
      } catch (error) {
        this.deletexiangmu = false;
      }
    },
    async beforeClose(done) {
      //弹框关闭事件
      (this.fromss = {
        userId: "", //
        projectAndUserList: [],
        projectId: "", //参与项项目
        contractId: "", //合同段
        roleIds: "", //用户类型
      }),
        await this.onLoad(this.page);
      done();
    },
    async removeUsersByIds(ids) {
      //删除参建项目
      this.deletexiangmu = true;
      try {
        const { data: res } = await removeUsersByIds(ids);
        console.log(res);
        if (res.code == 200) {
          this.$message({
            type: "success",
            message: "删除成功",
          });
          await this.findProjectAndContractList(this.fromss.userId);
        }
        this.deletexiangmu = false;
      } catch (error) {
        this.deletexiangmu = false;
      }
    },
    async getProjectList() {
      //项目类型
      const { data: res } = await getProjectListPage({ current: 1, size: 999 });
      console.log(res);
      if (res.code === 200) {
        this.projectData = res.data.records;
      }
    },
    async findContractByProjectId(pId) {
      //合同段
      const { data: res } = await findContractByProjectId(pId);
      console.log(res);
      if (res.code === 200) {
        this.contractData = res.data;
      }
    },
    async treeUser() {
      //获取用户类型枚举
      const { data: res } = await treeUser();
      console.log(res);
      if (res.code === 200) {
        this.roleIdsData = res.data;
      }
    },
    async findProjectAndContractList(userId) {
      //编辑获取参建项目
      const { data: res } = await findProjectAndContractList({ userId });

      if (res.code === 200) {
        res.data.forEach((val) => {
          val.isCanEditProjectRole = false; //是否可以编辑项目角色
          val.contractName = val.dataInfo[0].id;
          val.roleId = val.dataInfo[0].roleId;
          val.contractId = val.dataInfo[0].id;

          if (val.dataInfo[0].roleType) {
            val.roleName =
              val.dataInfo[0].roleType + " | " + val.dataInfo[0].roleName;
          } else {
            val.roleName = val.dataInfo[0].roleName;
          }
        });
        this.fromss.projectAndUserList = res.data;
        console.log("参建项目", this.fromss.projectAndUserList);
      }
    },
    async saveUserInfoByProjectTow(da) {
      //编辑添加参建项目
      const { data: res } = await saveUserInfoByProjectTow(da);
      console.log(res);
      if (res.code == 200) {
        // this.fromss.projectId = ''    //参与项项目
        // this.fromss.contractId = ''   //合同段
        // this.fromss.roleIds = ''      //用户类型
        this.findProjectAndContractList(this.fromss.userId);
      }
      this.$message({
        type: "success",
        message: "添加成功",
      });
    },
    //#endregion

    async updateContractRole(index = -1) {
      let array = [];
      if (index >= 0) {
        this.fromss.projectAndUserList[index].isCanEditProjectRole = false;
        array = this.fromss.projectAndUserList[index].dataInfo.map((el) => {
          return { id: el.id, roleId: el.roleId };
        });
      } else {
        console.log(this.fromss.projectAndUserList);
        this.fromss.projectAndUserList.forEach((el) => {
          if (el.isCanEditProjectRole) {
            array = array.concat(el.dataInfo.map((subEl) => ({ id: subEl.id, roleId: subEl.roleId })))
          }
        });
      }



      const { data: res } = await updateBatchUserRole({ userId: this.fromss.userId, list: array });
      if (res.code == 200) {

        if (index >= 0) {
          this.$message({
            type: "success",
            message: "修改成功!",
          });
          const el = { ...this.fromss.projectAndUserList[index] }
          console.log(el.dataInfo[0].roleName);
          const dataInfo = el.dataInfo.map((item) => ({
            ...item,
            roleName: item.roleName.split('|').length > 1 ? item.roleName.split(' | ')[1] : item.roleName.split(' | ')[0],
            roleType: item.roleName.split('|').length > 1 ? item.roleName.split(' | ')[0] : null
          }))

          this.$set(this.fromss.projectAndUserList, index, {
            ...el,
            dataInfo: [...dataInfo],
            contractName: el.dataInfo[0].id,
            contractId: el.dataInfo[0].id,
            roleName: dataInfo[0].roleType ? dataInfo[0].roleType + " | " + dataInfo[0].roleName : dataInfo[0].roleName
          })
        }
      }
    },

    //#region 甘云杰
    nodeClick(data) {
      this.addData = {
        tenantId: data.tenantId,
        deptId: data.id,
      };
      this.treeDeptId = data.id;
      this.page.currentPage = 1;
      this.onLoad(this.page);
    },
    initData(tenantId) {
      //所属部门
      getDeptTree(tenantId).then((res) => {
        const column = this.findObject(this.option.group, "deptId");
        column.dicData = res.data.data;
      });
    },
    submitRole() {
      const roleList = this.$refs.treeRole.getCheckedKeys().join(",");
      grant(this.ids, roleList).then(() => {
        this.roleBox = false;
        this.$message({
          type: "success",
          message: "操作成功!",
        });
        this.onLoad(this.page);
      });
    },
    rowSave(row, done, loading) {
      //新增保存
      console.log("保存", this.fromss.projectAndUserList);
      // 新增时：若未输入登录账号但输入了手机号，则自动用手机号作为登录账号
      if (!row.account && row.phone) {
        row.account = row.phone; // 将手机号赋值给登录账号
      }
      let projectAndUserList = [];
      this.fromss.projectAndUserList.forEach((val) => {
        if (val.dataInfo.length > 0) {
          val.dataInfo.forEach((item) => {
            projectAndUserList.push({
              projectId: val.projectId,
              contractId: item.id,
              roleId: item.roleIds,
            });
          });
        }
      });
      add({ ...row, projectAndUserList }).then(
        () => {
          this.initFlag = false;
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!",
          });
          done();
        },
        () => {
          loading();
        }
      );
    },
    rowUpdate(row, index, done, loading) {
      //修改按钮
      // row.roleId = row.roleId.join(",");
      // let array = []
      // let roleName = ""
      // this.fromss.projectAndUserList.forEach((el) => {
      //   if (el.isCanEditProjectRole) {
      //     console.log("111111",el.dataInfo);
      //     array = array.concat(el.dataInfo.map((subEl) => ({ id: subEl.id, roleId: subEl.roleId })))
      //   }
      // });



      console.log(row, "row");
      if (row.postId) {
        row.postId = row.postId.join(",");
      }

      let ks = { ...row };
      delete ks.projectAndUserList;
      delete ks.roleId;
      console.log(ks.userType, "userType");
      let userTypeArray = ks.userType.split(",");
      //正序排列
      userTypeArray
        .sort((a, b) => {
          return a - b;
        })
        .toString();
      ks.userType = userTypeArray.toString();
      update({ ...ks }).then(
        async () => {
          await this.updateContractRole();
          this.initFlag = false;
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!",
          });
          done();
        },
        () => {
          loading();
        }
      );
    },
    rowDel(row) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!",
          });
        });
    },
    searchReset() {
      this.query = {};
      this.treeDeptId = "";
      this.onLoad(this.page);
    },
    searchChange(params, done) {
      this.query = params;
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    selectionChange(list) {
      this.selectionList = list;
    },
    selectionClear() {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    handleDelete() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!",
          });
          this.$refs.crud.toggleSelection();
        });
    },
    handleReset() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择账号密码重置为123456?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return resetPassword(this.ids);
        })
        .then(() => {
          this.$message({
            type: "success",
            message: "操作成功!",
          });
          this.$refs.crud.toggleSelection();
        });
    },
    handleGrant() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.roleTreeObj = [];
      if (this.selectionList.length === 1) {
        this.roleTreeObj = this.selectionList[0].roleId.split(",");
      }
      roletree().then((res) => {
        this.roleGrantList = res.data.data;
        this.roleBox = true;
      });
    },
    handlePlatform() {
      this.platformBox = true;
    },
    handLock() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择账号封禁？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return lock(this.ids);
        })
        .then(() => {
          this.$message({
            type: "success",
            message: "操作成功!",
          });
        });
    },
    handleLock() {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择账号解封？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          return unlock(this.ids);
        })
        .then(() => {
          this.$message({
            type: "success",
            message: "操作成功!",
          });
        });
    },
    handleImport() {
      this.excelBox = true;
      this.excelForm = {
        excelFile: null,
        isCovered: 0,
      };
    },
    // uploadAfter(res, done, loading, column) {
    //   console.log(res, '111');
    //   console.log(done, '222');
    //   console.log(loading, '333');
    //   console.log(column, '444');
    //   if (!res) {
    //     this.excelBox = false;
    //     // 刷新数据列表
    //     this.refreshChange();
    //     this.$message.success("导入成功!");
    //   }
    //   done();
    // },
    handleExport() {
      this.$confirm("是否导出用户数据?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        NProgress.start();
        exportBlob(
          `/api/blade-user/export-user?${this.website.tokenHeader
          }=${getToken()}&account=${this.search.account}&realName=${this.search.realName
          }`
        ).then((res) => {
          downloadXls(res.data, `用户数据表${dateNow()}.xlsx`);
          NProgress.done();
        });
      });
    },
    handleTemplate() {
      // exportBlob(
      //   `/api/blade-user/export-template?${this.website.tokenHeader
      //   }=${getToken()}`
      // ).then((res) => {
      //   downloadXls(res.data, "用户数据模板.xlsx");
      // });
      exportBlob(
        `/api/blade-user/downloadImportUserExcel?${this.website.tokenHeader
        }=${getToken()}`
      ).then((res) => {
        downloadXls(res.data, "用户数据模板.xlsx");
      });
    },
    beforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getUser(this.form.id).then((res) => {
          this.form = res.data.data;
          if (this.form.hasOwnProperty("roleId")) {
            this.form.roleId = this.form.roleId.split(",");
          }
          if (this.form.hasOwnProperty("postId") && this.form.postId) {
            this.form.postId = this.form.postId.split(",");
          }
        });
      } else if (type === "add") {
        // 新增时设置默认账号和密码

        this.form.password = "user123456";
        this.form.password2 = "user123456";
      } else {
        this.form.tenantId = this.addData.tenantId;
      }

      this.initFlag = true;
      done();
    },
    currentChange(currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange(pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange() {
      this.onLoad(this.page, this.query);
    },
    onLoad(page, params = {}) {
      this.loading = true;
      getList(
        page.currentPage,
        page.pageSize,
        Object.assign(params, this.query),
        this.treeDeptId
      ).then((res) => {
        const data = res.data.data;
        this.page.total = data.total;
        this.data = data.records;
        this.loading = false;
        this.selectionClear();
      });
    },
    platformRowUpdate(row, index, done, loading) {
      updatePlatform(row.id, row.userType, row.userExt).then(
        () => {
          this.platformOnLoad(this.platformPage);
          this.$message({
            type: "success",
            message: "操作成功!",
          });
          done();
        },
        (error) => {
          window.console.log(error);
          loading();
        }
      );
    },
    platformBeforeOpen(done, type) {
      if (["edit", "view"].includes(type)) {
        getUserPlatform(this.platformForm.id).then((res) => {
          this.platformForm = res.data.data;
        });
      }
      done();
    },
    platformSearchReset() {
      this.platformQuery = {};
      this.platformOnLoad(this.platformPage);
    },
    platformSearchChange(params, done) {
      this.platformQuery = params;
      this.platformPage.currentPage = 1;
      this.platformOnLoad(this.platformPage, params);
      done();
    },
    platformSelectionChange(list) {
      this.platformSelectionList = list;
    },
    platformSelectionClear() {
      this.platformSelectionList = [];
      this.$refs.platformCrud.toggleSelection();
    },
    platformCurrentChange(currentPage) {
      this.platformPage.currentPage = currentPage;
    },
    platformSizeChange(pageSize) {
      this.platformPage.pageSize = pageSize;
    },
    platformRefreshChange() {
      this.platformOnLoad(this.platformPage, this.platformQuery);
    },
    platformOnLoad(page, params = {}) {
      this.platformLoading = true;
      getList(
        page.currentPage,
        page.pageSize,
        Object.assign(params, this.query),
        this.treeDeptId
      ).then((res) => {
        const data = res.data.data;
        this.platformPage.total = data.total;
        this.platformData = data.records;
        this.platformLoading = false;
        this.selectionClear();
      });
    },
    //#endregion
  },
};
</script>

<style lang="scss">
.box {
  height: 800px;
}

.el-scrollbar {
  height: 100%;
}

.box .el-scrollbar__wrap {
  overflow: scroll;
}

.my-basic-con {
  padding: 6px 6px;
}
</style>
